#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_GiftCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_GiftCFG> Fish_GiftCFG::msSingleton(nullptr);

int Fish_GiftCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GiftCFGData* Fish_GiftCFG::GetData(int Turret)
{
	auto it = mMapData.find(Turret);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_GiftCFGData>& Fish_GiftCFG::GetMapData()
{
	return mMapData;
}

void Fish_GiftCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_GiftCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GiftCFGData data;
		data.mTurret = element->IntAttribute("Turret");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		if (mMapData.find(data.mTurret) != mMapData.end())std::cout <<"data refind:" << data.mTurret << std::endl;
		assert(mMapData.find(data.mTurret) == mMapData.end());
		mMapData.insert(std::make_pair(data.mTurret, data));
		element = element->NextSiblingElement();
	}
}

void Fish_GiftCFG::Load()
{
	Load("../Config/Fish_GiftCFG.xml");
}

Fish_GiftCFG* Fish_GiftCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GiftCFG());
	}
	return msSingleton.get();
}
